;-------------------------------------------------------------------------------
;まず色々定義をします

;魚が暴れるキーフレームアニメを定義
[keyframe name="fishact"]
	[frame p=0% x=20 y=20]
	[frame p=50% x=10 rotate="10deg"]
	[frame p=100% x=-10 rotate="-10deg"]
[endkeyframe]

;定数の定義
;魚タイプ（配列番号が画像の番号に該当 / 0:小タイプ / 1:中タイプ / 2:大タイプ）
@eval exp="f.FISH_TYPE=[0,0,0,0,1,1,1,2,2,2]"

;小タイプ（簡単）の待ち時間
@eval exp="f.EASY_TYPE=1200"

;中タイプ（普通）の待ち時間
@eval exp="f.NORMAL_TYPE=900"

;大タイプ（難しい）の待ち時間
@eval exp="f.HARD_TYPE=700"


;-------------------------------------------------------------------------------
*main
;メイン画面
[wait_cancel]
[clearstack]
[cm]
[freeimage layer=0]
[freeimage layer=1]
[layopt layer=0 visible=true]
[layopt layer=1 visible=true]
[layopt layer=message0 visible=false]

;空を表示（背景）
[bg storage="sky.png" time=0]

;水を表示（レイヤー１）
[image layer=1 storage="sea.png" folder="image" x=0 y=290]

;タッチボタン
[clickable target="*start" width=960 height=640 x=0 y=0]

[s]


*start
;釣りをスタートする
[wait_cancel]
[clearstack]
[cm]
[freeimage layer=0]
[free name="effect" layer=1]

;糸を垂らす準備
@eval exp="f.tutu=0"
@eval exp="f.hit=0"
@eval exp="f.tutumax=Math.floor(Math.random()*4)"

;糸を表示（レイヤー０）
[image name="line" layer=0 storage="line.png" folder="image" x=470 y=-430]
[anim name="line" top="+=390" time=200]
[wait time=200]

;タッチボタン
[clickable target="*up" width=960 height=640 x=0 y=0]


*wait
;魚が来るまで待つ
@eval exp="tf.ran=Math.floor(Math.random()*1000)+500"
[wait time="&tf.ran"]


*fish_show
;魚が来る準備
@eval exp="f.hit=1"

;魚の種類を決める乱数
@eval exp="f.number=Math.floor(Math.random()*10)"

;魚の大きさ判定
;---小タイプ：簡単
[if exp="f.FISH_TYPE[f.number]==0"]
	[eval exp="f.type='fish1.png'"]
	[eval exp="f.wait=f.EASY_TYPE"]
;---中タイプ：普通
[elsif exp="f.FISH_TYPE[f.number]==1"]
	[eval exp="f.type='fish2.png'"]
	[eval exp="f.wait=f.NORMAL_TYPE"]
;---大タイプ：難しい
[else]
	[eval exp="f.type='fish3.png'"]
	[eval exp="f.wait=f.HARD_TYPE"]
[endif]

;魚を表示（レイヤー０）
[image layer=0 name="fish" storage="&f.type" folder="image" x=-80 y=360]
[anim name="fish" left="+=405" time=1000]
[wait time=1000]


*fish_poke
;魚の行動を待つ
@eval exp="tf.ran=Math.floor(Math.random()*1000)+500"
[wait time="&tf.ran"]

;魚がつつく
[anim name="fish" left="+=70" time=300]
[wait time=300]

;f.tutumaxの数だけ繰り返しつつく
[if exp="f.tutu>=f.tutumax||f.tutu>=5"]
	[jump target="*hit"]
[else]
	[eval exp="f.tutu+=1"]
	[jump target="*fish_back"]
[endif]

[s]


*fish_back
;魚が離れる
[anim name="fish" left="-=70" time=300]
[wait time=300]
@jump target="*fish_poke"
[s]


*hit
;ヒットした！
[kanim name="fish" keyframe="fishact" time=200 count="infinite"]
[anim name="line" top="+=20" time=200]
[image layer=1 name="sibuki" storage="hit.gif" folder="image" x=330 y=250]
@eval exp="f.hit=2"
[wait time="&f.wait"]

;時間オーバーで逃げられる
[cm]
[free layer=1 name="sibuki"]
[stop_kanim name="fish"]
[anim name="fish" left="-90" time=500]
[wait time=500]
[freeimage layer=0]

;逃げられたメッセージ表示
[ptext layer=1 name="effect" text="逃げられた…" width=960 x=0 y=200 size=28 align=center color="black"]

;タッチボタン
[clickable target="*start" width=960 height=640 x=0 y=0]

[s]


*up
;糸を引く
[wait_cancel]
[free layer=1 name="sibuki"]
[anim name="line" top="-=150" time=200]

[if exp="f.hit==2"]
;---魚釣り成功の場合
	[stop_kanim name="fish"]
	[anim name="fish" top="-=130" time=200]
	[wait time=500]
	[freeimage layer=0]
	[ptext layer=1 name="effect" text="お魚ゲット！！" width=960 x=0 y=30 size=50 align=center color=black]
	[image layer=1 name="effect" storage="&f.number+'.png'" x=405 y=200]

[elsif exp="f.hit==1"]
;---逃げられてしまう場合
	[stop_kanim name="fish"]
	[anim name="fish" left="-90" time=500]
	[wait time=500]
	[freeimage layer=0]
	[ptext layer=1 name="effect" text="逃げられた…" width=960 x=0 y=200 size=28 align=center color="black"]

[else]
	[freeimage layer=0]
;---まだ魚が来ていなかった場合
	[ptext layer=1 name="effect" text="何も釣れなかった…" width=960 x=0 y=200 size=28 align=center color="black"]

[endif]

;タッチボタン
[clickable target="*start" width=960 height=640 x=0 y=0]

[s]
